// *** starts or stops a defined process using passed in variables ***
// *** Two arguments are required - block and proc                 ***
// *** - proc is the full path to program to start                 ***
// *** - block is a boolean for process blocking or not and a      ***
// *** false or null value indicates no blocking - any assignment  ***
// *** will make blockingBool evaluate to true.                    ***
// *** Any number of args may be passed that makes sense

function speakit_init_process(block, proc) {
  var blockingBool;
  var procArgs = new Array();
  var progObj = new Object();
  var procToStart;

  var fileConstruct = Components.Constructor("@mozilla.org/file/local;1", "nsILocalFile");
  var filePath = new fileConstruct();

  var processIface = Components.classes["@mozilla.org/process/util;1"].createInstance();
  processIface = processIface.QueryInterface(Components.interfaces.nsIProcess);

  var userPrefs = Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPrefBranch);
 
 if(arguments[0] == "speakit") {
  var tempFile = arguments[1];
  try {
     arguments[0] = userPrefs.getBoolPref("speakit.Blocking");
     //alert("YES speakit.Blocking pref found: " + arguments[0]);
  } catch (e) {
     //alert("No speakit.Blocking pref found: " + e);
     userPrefs.setBoolPref("speakit.Blocking", false);
     arguments[0] = null;
  }

  try {
     arguments[1] = userPrefs.getCharPref("speakit.appStartup");
     //alert("YES speakit.appStartup pref found: " + arguments[1]);
  } catch (e) {
     //alert("No speakit.appStartup pref found: " + e);
     userPrefs.setCharPref("speakit.appStartup", "/usr/bin/audiowrapper");
     arguments[1] = userPrefs.getCharPref("speakit.appStartup");
  }

  try {
     var tempArgString = userPrefs.getCharPref("speakit.appStartup.args");
     var tempString = tempArgString.split(/\s/);
     var tempCount = arguments.length;
     //alert("Speakit App Args: " + tempString.length + " :: " + tempString[1]);
     
     for(var i = 0; i < tempString.length; i++) {
         arguments[tempCount] = tempString[i];
         //alert("Assinging argument from prefs: " + tempCount + arguments[tempCount]);
         tempCount++;
     }
     arguments[tempCount] = tempFile; 
     alert("KioskSpeakit Assinging argument filePath: " + tempCount + arguments[tempCount]);
     arguments.length = tempCount + 1;
  } catch (e) {
      //alert("No speakit.appStartup.args pref found: " + e);
      userPrefs.setCharPref("speakit.appStartup.args", "--oss-native /usr/bin/festival --tts");
     
  }
 }


  // ** Start loop at 2 since we just used the elements 0 and 1
  // ** and assign to procArgs array starting at element 0
  blockingBool = arguments[0];
  procToStart = arguments[1];
  for(var i = 2; i < arguments.length; i++) {
   procArgs[i - 2] = arguments[i];
   //alert("Assigning: " + (i - 2) + " :: " + procArgs[i - 2]);
  }

  filePath.initWithPath(procToStart);
  processIface.init(filePath);
  try { 
     progObj.value = 19;
     processIface.run( blockingBool, procArgs, procArgs.length, progObj);
     //alert("Just sent appStartup string " + procArgs.length);
  } catch (e) {
     alert("kioskSpeakit::startProc FAILURE OF RUN :: " + e + "\n");
  }
}

function speakit_kill_process(proc, arg) {
  var blockingBool;
  var procArgs = new Array();
  var progObj = new Object();
  var procToKill = proc;
  procArgs[0] = arg;

  var fileConstruct = Components.Constructor("@mozilla.org/file/local;1", "nsILocalFile");
  var filePath = new fileConstruct();

  var processIface = Components.classes["@mozilla.org/process/util;1"].createInstance();
  processIface = processIface.QueryInterface(Components.interfaces.nsIProcess);

  var userPrefs = Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPrefBranch);

  try {
     procArgs[0] = userPrefs.getCharPref("speakit.appKillall");
  } catch (e) {
     //alert("No speakit.appKillall pref found: " + e);
     userPrefs.setCharPref("speakit.appKillall", "/usr/bin/festival");
     procArgs[0] = userPrefs.getCharPref("speakit.appKillall");
  }


  try {
     filePath.initWithPath(procToKill);
     processIface.init(filePath);
     processIface.run( false, procArgs, procArgs.length, progObj);
  } catch (e) {
     //alert("Failure of KILL : " + e );
  }
}
